import * as singleSpa from 'single-spa';
import { registerApp, registerLocal } from './register'
window.LOADER_SPA = singleSpa
const _APPS = {}
singleSpa.addErrorHandler(function (err) {
  const app = location.hash.split('/')[1]
  const status = singleSpa.getAppStatus(app)
  console.log(app + ':捕捉到app错误...', status)
  let url = _APPS[app].main.indexOf('http') === 0 ? _APPS[app].main : location.origin + _APPS[app].main;
  System.delete(url);

  singleSpa.unloadApplication(app).then(function () {
    console.log(app + ':尝试处理app错误...', singleSpa.getAppStatus(app))
    if (status === singleSpa.SKIP_BECAUSE_BROKEN || status === singleSpa.LOADING_SOURCE_CODE) {
      window.dispatchEvent(new CustomEvent("single-spa:error-occured", err)); // 提示用户刷新
    }
  })
})

export async function initial(mode = 'development', options = {}) {
  const appConfig = await SystemJS.import('/apps.config.js')
  let { apps } = appConfig;
  let isRegisted = false;
  if (mode === 'development' && options.name) {
      apps = apps.filter(_ => _.name !== options.name)
  }
  if (options.base && options.preload) {
      isRegisted = true
      options.main && registerLocal(options)
  }
  // 注册
  for (let index = 0; index < apps.length; index++) {
      const app = apps[index];
      console.log(`registering remote app... -> ${app.name}`, app);
      await registerApp({
          name: app.name,
          base: app.base,
          useHashPath: app.useHashPath,
          path: app.path,
          main: app.main,
          routes: app.routes,
          isBaseRoute: app.isBaseRoute,
          store: app.store,
          url: app.preFilePath,
          filePatterns: app.filePatterns,
      });
  }
  if (!isRegisted) {
      options.main && registerLocal(options)
  }
  singleSpa.start();
}

// initial()