// 注册器
import * as singleSpa from 'single-spa';
import {hashPrefix, pathPrefix} from './path';

export function registerLocal({ base, main, path, isBaseRoute, routes, store, useHashPath, name = 'local' }) {
    // if (!isBaseRoute && routes) {
    // registerRoutes({ ...params, routes })
    // }

    let storeModule = {}, customProps = { };
    storeModule = store && { storeInstance: null };

    // if (storeModule.storeInstance && globalEventDistributor) {
    //     customProps.store = storeModule.storeInstance;
    //     globalEventDistributor.registerStore(storeModule.storeInstance);
    // }

    singleSpa.registerApplication(name, async () => main, base ? (() => true) : (useHashPath ? hashPrefix({ path }) : pathPrefix({ path })), customProps);
}

export function registerApp(params) {
    const customProps = {}

    // appName: string
    // 应用的名字将会在single-spa中注册和引用, 并在开发工具中标记。
    // applicationOrLoadingFn: () => <Function | Promise>
    // 必须是一个加载函数，返回一个应用或者一个Promise。
    // activityFn: (location) => boolean
    // 必须是个纯函数, 该函数由
    // window.location
    // 作为第一个参数被调用, 当应用应该被激活时它应该返回一个真值。
    // customProps?: Object =
    // 在生命周期钩子函数执行时会被作为参数传入

    singleSpa.registerApplication(
        params.name,
        () => SystemJS.import(params.main),
        params.base ? (() => true) : (params.useHashPath ? hashPrefix(params) : pathPrefix(params)),
        customProps
    );

}