var webpack = require("webpack");
const HTMLWebpackPlugin = require('html-webpack-plugin');
const CopyWebpackPlugin = require('copy-webpack-plugin');

const path = require("path")
console.log(process.env.NODE_ENV)
module.exports = {
    mode: 'production',
    entry: './src/main.js',
    output: {
        publicPath: "./",
        filename: 'Main.[chunkhash:8].js',
        path: path.resolve(__dirname, 'dist'),
        libraryTarget: 'umd',
    },
    
    module: {
        rules: [{
            test: /\.js/,
            exclude: /node_modules/,
            loader: 'babel-loader'
        },]
    },
    devServer: {
        contentBase:'./public/',
        host: "127.0.0.1",
        port: 3000,
        // index: 'index.html'
    },
    plugins: [
        // new CopyWebpackPlugin({patterns:[{
        //     from: path.resolve(__dirname, "./public"),
        //     to: path.resolve(__dirname,'./dist')
        // }]}),
        new HTMLWebpackPlugin({
            // inject: false,
            template: './public/index.html',
            minify: false
        }),
        
    ],
}